/* ----------------------------------------------------------------------------
 *  $RCSfile: esp.c,v $
 * 
 * $Revision: 1.5 $
 *   $Author: larse $
 *     $Date: 2000/06/07 16:43:17 $
 *    $State: Exp $
 * ----------------------------------------------------------------------------
 * Copyright 1999-2000, Lars Eggert <larse@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the "Artistic License" which comes with this
 * Kit.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * Artistic License for more details.
 * ----------------------------------------------------------------------------
 *
 * $Log: esp.c,v $
 * Revision 1.5  2000/06/07 16:43:17  larse
 * Moved software over to sourceforge.net under the Artistic License. No
 * functional changes to latest release.
 *
 * Revision 1.4  1999/05/18 00:47:23  larse
 * Added ARP/RARP and DVMRP. Factored out common code to basics.c. Added
 * IGMP traceroute (untested).
 *
 * Revision 1.3  1999/03/27 02:44:17  larse
 * Added support for ICMPv4 type 40 (security failure). CAIRN IPsec does
 * not seem to generate those, however. The -v option is now controls
 * more things and has been debugged. Minor cleanup of the code. Added
 * ipd script as a convenient shortcut, it may go away later.
 *
 * Revision 1.2  1999/03/26 00:59:44  larse
 * Now supporting options to inhibit host name lookups, hide link layer
 * headers and show payload data. Documented the code better. Fixed a
 * small bug in IP option handling. First cut at a README.
 *
 * Revision 1.1  1999/03/24 00:29:55  larse
 * Added support for IPIP tunnels, IPsec (AH and ESP) and raw data
 * output. Fixed bugs in the ICMPv4 module. Fixed bug printing certain
 * options in the IP module. Minor changes to other modules, mostly to
 * write raw data where it was omitted previously.
 *
 * ----------------------------------------------------------------------------
 */


/* Define a marker for ident(1). */
static const char rcsid[] = 
  "$Id: esp.c,v 1.5 2000/06/07 16:43:17 larse Exp $";


#include <stdio.h>

#include "ipdump.h"
#include "indent.h"
#include "scan.h"


/* local header id */
static const char hdr[] = "IP-ESP";


/* print esp */
void print_esp(void)
  {
  const u_long *seqno;
  const u_long *spi = (const u_long *)next(sizeof(u_long));

  iprintf(hdr, "security parameters index: %lu\n", ntohl(*spi));
  seqno = (const u_long *)next(sizeof(u_long));
  iprintf(hdr, "sequence number: %lu\n", ntohl(*seqno));
  iprintf(hdr, "payload/encrypted header fields: [%lu octet%s]", left(), 
	  left() == 1 ? "" : "s");
  if(verbose)
    {
    printf("\n");
    /* print esp data */
    indent_level++;
    print_raw(hdr, left());
    indent_level--;
    }
  else printf(" [omitted]\n");
  }
