/* ----------------------------------------------------------------------------
 *  $RCSfile: indent.c,v $
 * 
 * $Revision: 1.4 $
 *   $Author: larse $
 *     $Date: 2000/06/07 16:43:18 $
 *    $State: Exp $
 * ----------------------------------------------------------------------------
 * Copyright 1999-2000, Lars Eggert <larse@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the "Artistic License" which comes with this
 * Kit.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * Artistic License for more details.
 * ----------------------------------------------------------------------------
 *
 * $Log: indent.c,v $
 * Revision 1.4  2000/06/07 16:43:18  larse
 * Moved software over to sourceforge.net under the Artistic License. No
 * functional changes to latest release.
 *
 * Revision 1.3  1999/03/26 00:59:45  larse
 * Now supporting options to inhibit host name lookups, hide link layer
 * headers and show payload data. Documented the code better. Fixed a
 * small bug in IP option handling. First cut at a README.
 *
 * Revision 1.2  1999/03/23 03:07:05  larse
 * Added support for TCP and UDP. Cleaned up IP option handling and ICMP.
 *
 * Revision 1.1  1999/03/22 20:20:20  larse
 * First stable and partially working version. IPv4 and ICMPv4 are the
 * only supported protocols, but they work fine, even with
 * extensions. The reorganized code should allow for much easier
 * extensions for other protocols.
 *
 * ----------------------------------------------------------------------------
 */


/* Define a marker for ident(1). */
static const char rcsid[] = 
  "$Id: indent.c,v 1.4 2000/06/07 16:43:18 larse Exp $";


#include <stdarg.h>
#include <stdio.h>


int indent_level = 0;


int iprintf(const char * const hdr, const char *fmt, ...)
  {
  va_list ap;
  int printed = 0;
  int i;

  va_start(ap, fmt);
  /* print header and indentation */
  printed += printf("%s\t", hdr);
  for(i = 0; i < indent_level; i++) printed += printf("\t");
  /* print args */
  printed += vprintf(fmt, ap);
  va_end(ap);
  return printed;
  }

